unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, DICOMcm_TLB, ExtCtrls, ComCtrls, ImgList, StrUtils;

const
  Space30 : String ='                              ';
  Space12 : String ='            ';

type
  TForm1 = class(TForm)
    DICOMc1: TDICOMc;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    StoreSCPReceiveDir: TEdit;
    Label2: TLabel;
    StoreSCPPort: TEdit;
    CheckBox1: TCheckBox;
    StoreSCPAET: TEdit;
    Label6: TLabel;
    Button1: TButton;
    Button3: TButton;
    Label9: TLabel;
    GroupBox2: TGroupBox;
    Label10: TLabel;
    Label3: TLabel;
    StoreSCUHostName: TEdit;
    Label4: TLabel;
    StoreSCUPort: TEdit;
    StoreSCUDICOMFile: TEdit;
    Label5: TLabel;
    Label7: TLabel;
    StoreSCUCallingAET: TEdit;
    Label8: TLabel;
    StoreSCUCalledAET: TEdit;
    Button4: TButton;
    GroupBox3: TGroupBox;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    EchoSCUHostName: TEdit;
    EchoSCUPort: TEdit;
    EchoSCUCallingAET: TEdit;
    EchoSCUCalledAET: TEdit;
    Button7: TButton;
    GroupBox4: TGroupBox;
    Label14: TLabel;
    Label17: TLabel;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    GroupBox7: TGroupBox;
    Label18: TLabel;
    FindSCUHostName: TEdit;
    Label19: TLabel;
    FindSCUCallingAET: TEdit;
    Label20: TLabel;
    FindSCUCalledAET: TEdit;
    FindSCUPort: TEdit;
    Label21: TLabel;
    MoveSCUHostName: TEdit;
    Label22: TLabel;
    Label23: TLabel;
    MoveSCUPort: TEdit;
    MoveSCUCalledAET: TEdit;
    Label24: TLabel;
    MoveSCUCallingAET: TEdit;
    Label25: TLabel;
    Label26: TLabel;
    MoveSCUReceivePort: TEdit;
    MoveSCUReceiveDir: TEdit;
    Label27: TLabel;
    Label28: TLabel;
    MoveSCUMoveAET: TEdit;
    Button6: TButton;
    Button8: TButton;
    TreeView1: TTreeView;
    ImageList1: TImageList;
    Label29: TLabel;
    PID: TEdit;
    Label30: TLabel;
    PName: TEdit;
    Label31: TLabel;
    PMod: TEdit;
    Label32: TLabel;
    PDate: TEdit;
    Button9: TButton;
    TreeView2: TTreeView;
    CheckBox2: TCheckBox;
    GroupBox8: TGroupBox;
    ListBox1: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure TreeView1DblClick(Sender: TObject);
    procedure DICOMc1StoreSCPReceiveFile(ASender: TObject;
      const sReceivedFileName: WideString);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  //Useage:
  //StartStoreSCP(Port,AETitle,ReceieveDirectory)
  //If the "ReceieveDirectory" does not exists the service will not start
  //Return TRUE when sucess else return FALSE

  if CheckBox1.Checked then
    DICOMc1.StoreSCPSaveFileAsDateTime := True
  else
    DICOMc1.StoreSCPSaveFileAsDateTime := False;

  if CheckBox2.Checked then
    DICOMc1.StoreSCPSaveFileInSubDir := True
  else
    DICOMc1.StoreSCPSaveFileInSubDir := False;

  if DirectoryExists(StoreSCPReceiveDir.Text)=False then
    MkDir(StoreSCPReceiveDir.Text);

  if DICOMc1.StartStoreSCP(StrToInt(StoreSCPPort.Text),StoreSCPAET.Text,StoreSCPReceiveDir.Text) then
    Showmessage('StoreSCP started ok!');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  //Stop StoreSCP
  if DICOMc1.StopStoreSCP then
    Showmessage('StoreSCP Stopped!');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  //Set ActiveX to English Version
  DICOMc1.OCXLanguage := 1;

  //Set LicenseCode
  DICOMc1.LicenseCode := '123456';
  if DICOMc1.LicenseIsOK then
    Showmessage('Thanks for registration!');
  StoreSCUDICOMFile.Text:=ExtractFilePath(Application.ExeName) + 'DCMFILE.DCM';

  ListBox1.Clear;
  TreeView1.Items.Clear;
  TreeView2.Items.Clear;
  Button6.Click;
  Button8.Click;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if FileExists(StoreSCUDICOMFile.Text) then
  begin
    if DICOMc1.StartStoreSCU(StoreSCUDICOMFile.Text, StoreSCUHostName.Text, StrToInt(StoreSCUPort.Text), StoreSCUCalledAET.Text, StoreSCUCallingAET.Text) then
      MessageBox(Application.Handle,'Sucess: Send DICOM file ok!','StoreSCU',MB_OK+MB_ICONINFORMATION)
    else
      MessageBox(Application.Handle,'Error: Failed to send DICOM file!','StoreSCU',MB_OK+MB_ICONERROR);
  end
  else
  begin
    MessageBox(Application.Handle,'Error: DICOM file not found!','StoreSCU',MB_OK+MB_ICONERROR);
  end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then
    DICOMc1.StoreSCPSaveFileAsDateTime:=True
  else
    DICOMc1.StoreSCPSaveFileAsDateTime:=False;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //Stop StoreSCP
  DICOMc1.StopStoreSCP;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  if DICOMC1.StartEchoSCU(EchoSCUHostName.Text,StrToInt(EchoSCUPort.Text),EchoSCUCalledAET.Text,EchoSCUCallingAET.Text) then
    MessageBox(Application.Handle,'Success: Echo completed !','CEcho',MB_OK+MB_ICONINFORMATION)
  else
    MessageBox(Application.Handle,'Error: Echo failed !','CEcho',MB_OK+MB_ICONERROR);
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  DICOMc1.FindSCUIP:=FindSCUHostName.Text;
  DICOMc1.FindSCUPort:=StrToInt(FindSCUPort.Text);
  DICOMc1.FindSCUCallingAETitle:=FindSCUCallingAET.Text;
  DICOMc1.FindSCUCalledAETitle:=FindSCUCalledAET.Text;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  if DirectoryExists(MoveSCUReceiveDir.Text)=False then
  begin
    Showmessage('Error: MoveSCU receive dir '+MoveSCUReceiveDir.Text+'does not exists!');
    Exit;
  end;
  DICOMc1.MoveSCUIP:=MoveSCUHostName.Text;
  DICOMc1.MoveSCUPort:=StrToInt(MoveSCUPort.Text);
  DICOMc1.MoveSCUCallingAETitle:=MoveSCUCallingAET.Text;
  DICOMc1.MoveSCUCalledAETitle:=MoveSCUCalledAET.Text;
  DICOMc1.MoveSCUReceiveDir:=MoveSCUReceiveDir.Text;
  DICOMc1.MoveSCUReceivePort:=StrToInt(MoveSCUReceivePort.Text);
  DICOMc1.MoveSCUMoveDstAETitle:=MoveSCUMoveAET.Text;
end;

procedure TForm1.Button9Click(Sender: TObject);
var
  iCount, iT : Integer;
  sTemp : String;
begin

//If DICOMc1.GetPatientList(PID.Text, PName.Text, PDate.Text, PMod.Text) = True Then

    if DICOMc1.GetPatientList(PID.Text, PName.Text, PDate.Text, PMod.Text) = true then
    begin
      TreeView1.Items.Clear;
      TreeView2.Items.Clear;
      iCount := DICOMc1.PatientListItemCount;
      for iT := 1 to iCount do
      begin
        DICOMc1.PatientListItemPos := iT;
        with DICOMc1.CurrentPatientList do
        begin
          sTemp := ' PName: ' + LeftStr(PatientName + Space30, 30) + 'ID: ' + LeftStr(PatientID + Space12, 12);
        end;
        TreeView1.Items.Add(TreeView1.TopItem, sTemp);
        TreeView1.Items.Item[iT-1].ImageIndex:=1;
        TreeView2.Items.Add(TreeView2.TopItem,'[1]'+DICOMc1.CurrentPatientList.StudyInstanceUID);
      end;
    end
    else
      Showmessage('Get PatientList failed !');

end;

procedure TForm1.TreeView1DblClick(Sender: TObject);
var
  iCount, iT, iType : Integer;
  sTemp,sStudyUID,sSeriesUID,sSOPUID : String;
begin
  if TreeView1.Items.Count > 0 then
  begin
    try
      iType := StrToInt(MidStr(LeftStr(TreeView2.Items.Item[TreeView1.Selected.AbsoluteIndex].Text, 3), 2, 1));
    except
      Showmessage('Error in list, unable to query!');
      Exit;
    end;

    Case iType of
    1:
      begin
        if TreeView1.Selected.HasChildren then
        begin
          TreeView1.Selected.DeleteChildren;
          TreeView2.Items.Item[TreeView1.Selected.AbsoluteIndex].DeleteChildren;
        end;
        sStudyUID:=TreeView2.Items.Item[TreeView1.Selected.AbsoluteIndex].Text;
        if DICOMc1.GetSeriesList(RightStr(sStudyUID, Length(sStudyUID) - 3), '*') = true then
        begin
          iCount := DICOMc1.PatientSeriesListItemCount;
          for iT := 1 To iCount do
          begin
            DICOMc1.PatientSeriesListItemPos := iT;
            sTemp := 'SType: ' + DICOMc1.CurrentPatientSeriesList.Modality;
            TreeView1.Items.AddChild(TreeView1.Selected,sTemp);
            TreeView1.Items.Item[TreeView1.Selected.AbsoluteIndex+iT].ImageIndex:=2;
            TreeView2.Items.AddChild(TreeView2.Items.Item[TreeView1.Selected.AbsoluteIndex],'[2]' + DICOMc1.CurrentPatientSeriesList.SeriesInstanceUID);
          end;
          TreeView1.Selected.Expand(true);
        end
        else
          Showmessage('Failed to GetSeriesList!');
      end;

    2:
      begin
        if TreeView1.Selected.HasChildren then
        begin
          TreeView1.Selected.DeleteChildren;
          TreeView2.Items.Item[TreeView1.Selected.AbsoluteIndex].DeleteChildren;
        end;
        sStudyUID:=TreeView2.Items.Item[TreeView1.Selected.AbsoluteIndex].Parent.Text;
        sSeriesUID:=TreeView2.Items.Item[TreeView1.Selected.AbsoluteIndex].Text;
        if DICOMc1.GetImageList(RightStr(sStudyUID, Length(sStudyUID) - 3), RightStr(sSeriesUID, Length(sSeriesUID) - 3), '*') = true then
        begin

          iCount := DICOMc1.PatientImageListItemCount;
          for iT := 1 To iCount do
          begin
            DICOMc1.PatientImageListItemPos := iT;
            sTemp := 'SNo: ' + DICOMc1.CurrentPatientImageList.InstanceNumber;
            TreeView1.Items.AddChild(TreeView1.Selected,sTemp);
            TreeView1.Items.Item[TreeView1.Selected.AbsoluteIndex+iT].ImageIndex:=3;
            TreeView2.Items.AddChild(TreeView2.Items.Item[TreeView1.Selected.AbsoluteIndex],'[3]' + DICOMc1.CurrentPatientImageList.SOPInstanceUID);
          end;
          TreeView1.Selected.Expand(true);
        end
        else
          Showmessage('Failed to GetImageList!');
      end;

      else
      begin
        sStudyUID:=TreeView2.Items.Item[TreeView1.Selected.AbsoluteIndex].Parent.Parent.Text;
        sSeriesUID:=TreeView2.Items.Item[TreeView1.Selected.AbsoluteIndex].Parent.Text;
        sSOPUID:=TreeView2.Items.Item[TreeView1.Selected.AbsoluteIndex].Text;
        if DICOMc1.GetImage(RightStr(sStudyUID, Length(sStudyUID) - 3),
                            RightStr(sSeriesUID, Length(sSeriesUID) - 3),
                            RightStr(sSOPUID, Length(sSOPUID) - 3)) = true then
          ShowMessage('Send retrieve command ok !')
        else
          Showmessage('Failed to retrieve the Image!');

      end;
    end;
  end;

end;

procedure TForm1.DICOMc1StoreSCPReceiveFile(ASender: TObject;
  const sReceivedFileName: WideString);
begin
  ListBox1.Items.Append(FormatDateTime('YYYY-MM-DD HH:MM:SS',Now) + ' - ' + sReceivedFileName);
end;

end.
